# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Net-IDN-Encode
Summary:	Internationalizing Domain Names in Applications (IDNA)
Version:	2.400
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Net-IDN-Encode/
Source0:	http://search.cpan.org/CPAN/authors/id/C/CF/CFAERBER/Net-IDN-Encode-%{version}.tar.gz
Patch0:		Net-IDN-Encode-2.400-5.8.patch
Patch1:		Net-IDN-Encode-2.400-UTF8.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Module::Build)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(integer)
BuildRequires:	perl(strict)
BuildRequires:	perl(Unicode::Normalize)
BuildRequires:	perl(utf8)
BuildRequires:	perl(warnings)
BuildRequires:	perl(XSLoader)
# Test Suite
BuildRequires:	perl(bytes)
BuildRequires:	perl(open)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::NoWarnings)
BuildRequires:	perl(Unicode::UCD)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(XSLoader)

# Don't "provide" private Perl libs
%{?perl_default_filter}

%description
This module provides an easy-to-use interface for encoding and decoding
Internationalized Domain Names (IDNs).

%prep
%setup -q -n Net-IDN-Encode-%{version}

# Fix tests to work with perl 5.8 too
%patch0

# Re-code docs as UTF8
%patch1

# Remove incorrect executable bits
chmod -c -x lib/Net/IDN/Encode.pm lib/Net/IDN/Standards.pod

%build
perl Build.PL --installdirs=vendor --optimize="%{optflags}"
./Build

%install
rm -rf %{buildroot}
./Build install --destdir=%{buildroot} --create_packlist=0
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} -c %{buildroot}

%check
./Build test

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes eg README
%{perl_vendorarch}/auto/Net/
%{perl_vendorarch}/Net/
%{_mandir}/man3/Net::IDN::Encode.3*
%{_mandir}/man3/Net::IDN::Overview.3*
%{_mandir}/man3/Net::IDN::Punycode.3*
%{_mandir}/man3/Net::IDN::Punycode::PP.3*
%{_mandir}/man3/Net::IDN::Standards.3*
%{_mandir}/man3/Net::IDN::UTS46.3*
%{_mandir}/man3/Net::IDN::UTS46::_Mapping.3*

%changelog
* Sun Jan  1 2017 Paul Howarth <paul@city-fan.org> - 2.400-1
- Update to 2.400
  - Update to Unicode 9.0.0
  - Changed generation of tests so that TODO is no longer required when the
    module author's perl doesn't support the newest Unicode version
  - Spelling fixes (CPAN RT#119468)
  - Possible fix for utf8 warnings under perl 5.8.x
  - Remove author tests
  - More spelling fixes
- Update patches as needed

* Sat Dec 10 2016 Paul Howarth <paul@city-fan.org> - 2.303-1
- Update to 2.303
  - Fix Punycode.xs to work on older perls
- Update patches as needed

* Thu Dec  8 2016 Paul Howarth <paul@city-fan.org> - 2.302-1
- Update to 2.302
  - Fixes memory bug introduced by fix for CPAN RT#118924
- Add further patch to fix broken upstream change

* Sun Dec  4 2016 Paul Howarth <paul@city-fan.org> - 2.301-1
- Update to 2.301
  - Fix encode_punycode heap overflow (CPAN RT#118924)
- Add patch to fix broken upstream change
- Update patches as needed

* Tue Sep 13 2016 Paul Howarth <paul@city-fan.org> - 2.300-4
- BR: perl-devel and perl-generators where available
- Simplify find command using -empty and -delete

* Sat Jul 18 2015 Paul Howarth <paul@city-fan.org> - 2.300-1
- Update to 2.300
  - Update to Unicode 8.0.0
- Update patches as needed

* Tue Jun 23 2015 Paul Howarth <paul@city-fan.org> - 2.202-3
- Perl 5.22 rebuild

* Mon Apr 20 2015 Paul Howarth <paul@city-fan.org> - 2.202-1
- Update to 2.202
  - Use updated IdnaTest.txt from Unicode 7.0.0 database (CPAN RT#96749)
  - Documentation updates, point to perl Unicode tutorials
- Update patches as needed

* Tue Sep  2 2014 Paul Howarth <paul@city-fan.org> - 2.201-2
- Update to 2.201
  - Correct handling of uppercase a-labels in domain_to_{ascii,unicode}
    (CPAN RT#98354)
- Use %%license where possible

* Mon Jun 23 2014 Paul Howarth <paul@city-fan.org> - 2.200-1
- Update to 2.200
  - Net::IDN::UTS46: update to Unicode® 7.0.0 and UTS #46 r13
  - Typo and metadata fixes
- Update patches as needed

* Fri Apr  4 2014 Paul Howarth <paul@city-fan.org> - 2.100-1
- Import from Fedora
- Update to 2.100

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.003-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Jul 20 2013 Petr Pisar <ppisar@redhat.com> - 2.003-4
- Perl 5.18 rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.003-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Jan 17 2013 Mathieu Bridon <bochecha@fedoraproject.org> - 2.003-2
- Add missing build requirements
- Add a requirement left out by rpmbuild
- Remove the incorrect executable bits
- Make sure all files are UTF-8 encoded

* Wed Jan 02 2013 Mathieu Bridon <bochecha@fedoraproject.org> - 2.003-1
- Initial package for Fedora, with help from cpanspec
